Strategic Game(树形DP)

Posted tttfu

tags:

篇首语:本文由小常识网(cha138.com)小编为大家整理,主要介绍了Strategic Game(树形DP)相关的知识,希望对你有一定的参考价值。

Strategic Game(树形DP)

题目

Bob enjoys playing computer games, especially strategic games, but sometimes he cannot find the solution fast enough and then he is very sad. Now he has the following problem. He must defend a medieval city, the roads of which form a tree. He has to put the minimum number of soldiers on the nodes so that they can observe all the edges. Can you help him?

Your program should find the minimum number of soldiers that Bob has to put for a given tree.

The input file contains several data sets in text format. Each data set represents a tree with the following description:

the number of nodes
the description of each node in the following format

node_identifier:(number_of_roads) node_identifier1 node_identifier2 ... node_identifier 
or 
node_identifier:(0) 

The node identifiers are integer numbers between 0 and n-1, for n nodes (0 < n <= 1500). Every edge appears only once in the input data.

For example for the tree:

技术图片

the solution is one soldier ( at the node 1).

The output should be printed on the standard output. For each given input data set, print one integer number in a single line that gives the result (the minimum number of soldiers). An example is given in the following table:
Input
4
0:(1) 1
1:(2) 2 3
2:(0)
3:(0)
5
3:(3) 1 4 2
1:(1) 0
2:(0)
0:(0)
4:(0)
Output
1
2
Sample Input
4
0:(1) 1
1:(2) 2 3
2:(0)
3:(0)
5
3:(3) 1 4 2
1:(1) 0
2:(0)
0:(0)
4:(0)
Sample Output
1
2

题意

给定一棵树,树的每一个边至少要有一个点,求最少要多少点。

思路

简单的树形dp

  • 因为要从自己点推父节点,所以可以使用递归。
  • 父节点不放的话,子节点必须放。父节点放的话子节点可放可不放。
    故得到:
    dp[u][0] += dp[v][1];
    dp[u][1] += min(dp[v][0], dp[v][1]);

题解

//简单的树形dp
#include <iostream>
#include <cstdio>
#include <cstring>
#include <vector>
#define N 1805
using namespace std;

vector<int> eg[N];
int dp[N][N];
int parent[N];
int n;

int dfs(int u)

   dp[u][0] = 0;
   dp[u][1] = 1;//自己放的话先加上自己的,子节点的在下面遍历他们的时候会加上。

   for (int i = 0; i < eg[u].size(); i++)
   
      int v = eg[u][i];
      dfs(v);
      dp[u][0] += dp[v][1];
      dp[u][1] += min(dp[v][0], dp[v][1]);
   


int main()


   while (scanf("%d", &n) != EOF)
   
      memset(parent, -1, sizeof parent);
      memset(dp, 0, sizeof dp);
      int x, k, y;
      for (int i = 0; i < n; i++)
      
         scanf("%d:(%d)", &x, &k);
         for (int j = 0; j < k; j++)
         
            scanf("%d", &y);
            parent[y] = x;
            eg[x].push_back(y);
         
      

      int root = 0;
      while (parent[root] != -1)
      
         root = parent[root];
      
      dfs(root);
      cout << min(dp[root][0], dp[root][1]) << endl;
      for (int i = 0; i < n; i++)
         eg[i].clear();
      //
   

以上是关于Strategic Game(树形DP)的主要内容,如果未能解决你的问题,请参考以下文章

HDU - 1054 Strategic Game 树形DP

HDU 1054 Strategic Game(树形dp)

HDU 1054 Strategic Game(树形DP)

UVALive - 2038 Strategic game (无向+记忆化+简单树形DP)

树形dp compare E - Cell Phone Network POJ - 3659 B - Strategic game POJ - 1463

POJ1463 Strategic game (最小点覆盖 or 树dp)